(function() {
  var fs, fsAdditions, ncp, wrench, _;

  fs = require('fs-plus');

  _ = require('underscore-plus');

  wrench = require('wrench');

  ncp = require('ncp');

  fsAdditions = {
    list: function(directoryPath) {
      var e;
      if (fs.isDirectorySync(directoryPath)) {
        try {
          return fs.readdirSync(directoryPath);
        } catch (_error) {
          e = _error;
          return [];
        }
      } else {
        return [];
      }
    },
    listRecursive: function(directoryPath) {
      return wrench.readdirSyncRecursive(directoryPath);
    },
    cp: function(sourcePath, destinationPath, callback) {
      fs.removeSync(destinationPath);
      return ncp(sourcePath, destinationPath, callback);
    }
  };

  module.exports = _.extend({}, fs, fsAdditions);

}).call(this);
